import { b9 as m, bg as B, fy as U, dT as E, c1 as x, V as i, fz as T, d4 as _, d5 as q, P as J, d6 as K, bh as Q, cy as X, fA as Y, fB as Z, d7 as tt, O as et, db as it, dc as nt } from "./23b8c60a.js";
import { createContext as ot, useRef as at, useContext as W, useMemo as o } from "react";
import { ContextContainerComp as rt } from "./d66a70f2.js";
import "react-dom";
const st = m.div`
  height: 100%;
  border: 1px solid ${(e) => e.$style.border};
  border-radius: ${(e) => e.$style.radius};
  padding: 3px ${(e) => e.$paddingWidth};
  background-color: ${(e) => e.$style.background};
`, ct = m.div`
  display: flex;
  align-items: center;
  justify-content: center;
  padding: 3px;
`, dt = m.div`
  height: ${(e) => e.$autoHeight ? "100%" : "calc(100% - 32px)"};
`, lt = m.div` 
  height: 100%;
  display: flex;
  align-items: center;
  // justify-content: center;
`, gt = m.div`
  height: ${(e) => e.$autoHeight ? "auto" : "100%"};
  display: flex;
  flex-direction: ${(e) => e.$isHorizontal && !e.$isGrid ? "row" : "column"};
  height: 100%;
`, V = ot({
  horizontalWidth: "100%",
  minHorizontalWidth: "100px"
}), ht = (e) => {
  const {
    horizontalWidth: l,
    minHorizontalWidth: t
  } = W(V);
  return /* @__PURE__ */ i("div", {
    style: {
      width: l,
      minWidth: t || "0px"
    },
    children: /* @__PURE__ */ i(it, {
      ...e,
      emptyRows: 15,
      containerPadding: [4, 4],
      hintPlaceholder: nt
    })
  });
};
function mt({
  minHorizontalWidth: e,
  horizontalWidth: l,
  ...t
}) {
  const {
    itemIdx: c,
    offset: a,
    containerProps: d,
    autoHeight: w,
    scrollContainerRef: y,
    minHeight: p
  } = t;
  return /* @__PURE__ */ i(V.Provider, {
    value: {
      horizontalWidth: l,
      minHorizontalWidth: e
    },
    children: /* @__PURE__ */ i(ht, {
      layout: d.layout,
      items: tt(d.items),
      positionParams: d.positionParams,
      dispatch: c === a ? d.dispatch : x.noop,
      style: {
        height: "100%",
        // in case of horizontal mode, minHorizontalWidth is 0px
        width: e || "100%",
        backgroundColor: "transparent"
        // flex: "auto",
      },
      autoHeight: w,
      isDroppable: c === a,
      isDraggable: c === a,
      isResizable: c === a,
      isSelectable: c === a,
      scrollContainerRef: y,
      overflow: "hidden",
      minHeight: p,
      enableGridLines: !0
    })
  });
}
function yt(e) {
  const {
    comp: l
  } = e, t = l.children, c = at(null), a = W(B), d = a.isDragging, [w, y] = U(0, d), p = o(() => t.dynamicHeight.getView(), [t.dynamicHeight]), v = o(() => t.heightUnitOfRow.getView(), [t.heightUnitOfRow]), P = o(() => t.container.getView(), [t.container]), R = o(() => t.itemIndexName.getView(), [t.itemIndexName]), S = o(() => t.itemDataName.getView(), [t.itemDataName]), {
    data: I,
    itemCount: z
  } = o(() => E(t.noOfRows.getView()), [t.noOfRows]), u = o(() => t.autoHeight.getView(), [t.autoHeight]), O = o(() => t.scrollbars.getView(), [t.scrollbars]), $ = o(() => t.horizontal.getView(), [t.horizontal]), D = o(() => t.minHorizontalWidth.getView(), [t.minHorizontalWidth]), h = o(() => Math.max(1, t.noOfColumns.getView()), [t.noOfColumns]), r = o(() => {
    const s = t.pagination.getView(), g = s.total || z;
    let f = s.current, n = (f - 1) * s.pageSize;
    const H = Math.max(0, Math.min(s.pageSize, g - n));
    return {
      pagination: {
        ...s,
        current: f,
        total: g
      },
      offset: n,
      currentPageSize: H,
      total: g
    };
  }, [t.pagination, z]), C = t.style.getView(), M = l.realSimpleContainer().children.layout.getView(), b = r.currentPageSize > 0 && (x.isEmpty(M) || a.isDragging), L = b ? 1 : Math.floor((r.currentPageSize + h - 1) / h), k = b ? "100%" : p ? "auto" : v * 44 + "px", N = d && u ? w + "px" : "100%", F = x.range(0, L).map((s) => /* @__PURE__ */ i("div", {
    style: {
      height: k,
      width: "100%"
    },
    children: /* @__PURE__ */ i(lt, {
      children: x.range(0, h).map((f) => {
        const n = s * h + f + r.offset;
        if (n >= r.total || n >= r.offset + r.pagination.pageSize || b && n > r.offset)
          return /* @__PURE__ */ i("div", {
            style: {
              flex: "auto"
            }
          }, n);
        const H = P({
          [R]: n,
          [S]: T(I, n)
        }, String(n)).getView(), A = () => {
          l.children.container.dispatch(et(rt.batchDeleteAction([String(n)])));
        };
        return /* @__PURE__ */ i(mt, {
          itemIdx: n,
          offset: r.offset,
          containerProps: H,
          autoHeight: d || p,
          scrollContainerRef: c,
          minHeight: N,
          unMountFn: A,
          horizontalWidth: `${100 / h}%`,
          minHorizontalWidth: $ ? D : void 0
        }, n);
      })
    })
  }, s)), G = a.getAppSettings().maxWidth, j = _(G) ? "4px" : "16px";
  return /* @__PURE__ */ i(q.Provider, {
    value: C.background,
    children: /* @__PURE__ */ J(st, {
      $style: C,
      $paddingWidth: j,
      children: [/* @__PURE__ */ i(dt, {
        ref: c,
        $autoHeight: u,
        children: /* @__PURE__ */ i(K, {
          style: {
            height: u ? "auto" : "100%",
            margin: "0px",
            padding: "0px"
          },
          hideScrollbar: !O,
          children: /* @__PURE__ */ i(Q, {
            children: /* @__PURE__ */ i(X, {
              onResize: (s, g) => {
                g && y(g);
              },
              observerOptions: {
                box: "border-box"
              },
              children: /* @__PURE__ */ i(gt, {
                $isHorizontal: $,
                $isGrid: h > 1,
                $autoHeight: u,
                children: F
              })
            })
          })
        })
      }), /* @__PURE__ */ i(ct, {
        children: /* @__PURE__ */ i(Y, {
          size: "small",
          itemRender: Z,
          ...r.pagination
        })
      })]
    })
  });
}
export {
  yt as ListView
};
